Index: source/simulation2/components/CCmpUnitMotion.cpp
===================================================================
--- source/simulation2/components/CCmpUnitMotion.cpp	(revision 13108)
+++ source/simulation2/components/CCmpUnitMotion.cpp	(working copy)
@@ -38,6 +38,10 @@
 #include "ps/Profile.h"
 #include "renderer/Scene.h"
 
+// For debugging; units will start going straight to the target
+// instead of calling the pathfinder
+#define DISABLE_PATHFINDER 0
+
 /**
  * When advancing along the long path, and picking a new waypoint to move
  * towards, we'll pick one that's up to this far from the unit's current
@@ -98,7 +102,7 @@
 static const CColor OVERLAY_COLOUR_LONG_PATH(1, 1, 1, 1);
 static const CColor OVERLAY_COLOUR_SHORT_PATH(1, 0, 0, 1);
 
-static const entity_pos_t g_GoalDelta = entity_pos_t::FromInt(TERRAIN_TILE_SIZE)/4; // for extending the goal outwards/inwards a little bit
+static const entity_pos_t g_GoalDelta = ICmpObstructionManager::NAVCELL_SIZE; // for extending the goal outwards/inwards a little bit
 
 class CCmpUnitMotion : public ICmpUnitMotion
 {
@@ -123,7 +127,6 @@
 	fixed m_WalkSpeed; // in metres per second
 	fixed m_RunSpeed;
 	ICmpPathfinder::pass_class_t m_PassClass;
-	ICmpPathfinder::cost_class_t m_CostClass;
 
 	// Dynamic state:
 
@@ -236,7 +239,7 @@
 	ICmpPathfinder::Path m_LongPath;
 	ICmpPathfinder::Path m_ShortPath;
 
-	ICmpPathfinder::Goal m_FinalGoal;
+	PathGoal m_FinalGoal;
 
 	static std::string GetSchema()
 	{
@@ -245,7 +248,6 @@
 			"<a:example>"
 				"<WalkSpeed>7.0</WalkSpeed>"
 				"<PassabilityClass>default</PassabilityClass>"
-				"<CostClass>infantry</CostClass>"
 			"</a:example>"
 			"<element name='FormationController'>"
 				"<data type='boolean'/>"
@@ -266,9 +268,6 @@
 			"</optional>"
 			"<element name='PassabilityClass' a:help='Identifies the terrain passability class (values are defined in special/pathfinder.xml)'>"
 				"<text/>"
-			"</element>"
-			"<element name='CostClass' a:help='Identifies the movement speed/cost class (values are defined in special/pathfinder.xml)'>"
-				"<text/>"
 			"</element>";
 	}
 
@@ -298,7 +297,6 @@
 		if (cmpPathfinder)
 		{
 			m_PassClass = cmpPathfinder->GetPassabilityClass(paramNode.GetChild("PassabilityClass").ToUTF8());
-			m_CostClass = cmpPathfinder->GetCostClass(paramNode.GetChild("CostClass").ToUTF8());
 		}
 
 		CmpPtr<ICmpObstruction> cmpObstruction(GetSimContext(), GetEntityId());
@@ -312,7 +310,7 @@
 
 		m_TargetEntity = INVALID_ENTITY;
 
-		m_FinalGoal.type = ICmpPathfinder::Goal::POINT;
+		m_FinalGoal.type = PathGoal::POINT;
 
 		m_DebugOverlayEnabled = false;
 	}
@@ -568,17 +566,17 @@
 	 * Might go in a straight line immediately, or might start an asynchronous
 	 * path request.
 	 */
-	void BeginPathing(CFixedVector2D from, const ICmpPathfinder::Goal& goal);
+	void BeginPathing(CFixedVector2D from, const PathGoal& goal);
 
 	/**
 	 * Start an asynchronous long path query.
 	 */
-	void RequestLongPath(CFixedVector2D from, const ICmpPathfinder::Goal& goal);
+	void RequestLongPath(CFixedVector2D from, const PathGoal& goal);
 
 	/**
 	 * Start an asynchronous short path query.
 	 */
-	void RequestShortPath(CFixedVector2D from, const ICmpPathfinder::Goal& goal, bool avoidMovingUnits);
+	void RequestShortPath(CFixedVector2D from, const PathGoal& goal, bool avoidMovingUnits);
 
 	/**
 	 * Select a next long waypoint, given the current unit position.
@@ -824,7 +822,8 @@
 		// Find the speed factor of the underlying terrain
 		// (We only care about the tile we start on - it doesn't matter if we're moving
 		// partially onto a much slower/faster tile)
-		fixed terrainSpeed = cmpPathfinder->GetMovementSpeed(pos.X, pos.Y, m_CostClass);
+		// TODO: Terrain-dependent speeds are not currently supported
+		fixed terrainSpeed = fixed::FromInt(1);
 
 		fixed maxSpeed = basicSpeed.Multiply(terrainSpeed);
 
@@ -1025,7 +1024,7 @@
 		return false;
 
 	// Move the goal to match the target entity's new position
-	ICmpPathfinder::Goal goal = m_FinalGoal;
+	PathGoal goal = m_FinalGoal;
 	goal.x = targetPos.X;
 	goal.z = targetPos.Y;
 	// (we ignore changes to the target's rotation, since only buildings are
@@ -1147,7 +1146,7 @@
 
 
 
-void CCmpUnitMotion::BeginPathing(CFixedVector2D from, const ICmpPathfinder::Goal& goal)
+void CCmpUnitMotion::BeginPathing(CFixedVector2D from, const PathGoal& goal)
 {
 	// Cancel any pending path requests
 	m_ExpectedPathTicket = 0;
@@ -1160,6 +1159,19 @@
 	if (cmpObstruction)
 		cmpObstruction->SetMovingFlag(true);
 
+#if DISABLE_PATHFINDER
+	{
+		CmpPtr<ICmpPathfinder> cmpPathfinder (GetSimContext(), SYSTEM_ENTITY);
+		CFixedVector2D goalPos = cmpPathfinder->GetNearestPointOnGoal(from, m_FinalGoal);
+		m_LongPath.m_Waypoints.clear();
+		m_ShortPath.m_Waypoints.clear();
+		ICmpPathfinder::Waypoint wp = { goalPos.X, goalPos.Y };
+		m_ShortPath.m_Waypoints.push_back(wp);
+		m_PathState = PATHSTATE_FOLLOWING;
+		return;
+	}
+#endif
+
 	// If we're aiming at a target entity and it's close and we can reach
 	// it in a straight line, then we'll just go along the straight line
 	// instead of computing a path.
@@ -1181,18 +1193,18 @@
 	RequestLongPath(from, goal);
 }
 
-void CCmpUnitMotion::RequestLongPath(CFixedVector2D from, const ICmpPathfinder::Goal& goal)
+void CCmpUnitMotion::RequestLongPath(CFixedVector2D from, const PathGoal& goal)
 {
 	CmpPtr<ICmpPathfinder> cmpPathfinder(GetSimContext(), SYSTEM_ENTITY);
 	if (!cmpPathfinder)
 		return;
 
-	cmpPathfinder->SetDebugPath(from.X, from.Y, goal, m_PassClass, m_CostClass);
+	cmpPathfinder->SetDebugPath(from.X, from.Y, goal, m_PassClass);
 
-	m_ExpectedPathTicket = cmpPathfinder->ComputePathAsync(from.X, from.Y, goal, m_PassClass, m_CostClass, GetEntityId());
+	m_ExpectedPathTicket = cmpPathfinder->ComputePathAsync(from.X, from.Y, goal, m_PassClass, GetEntityId());
 }
 
-void CCmpUnitMotion::RequestShortPath(CFixedVector2D from, const ICmpPathfinder::Goal& goal, bool avoidMovingUnits)
+void CCmpUnitMotion::RequestShortPath(CFixedVector2D from, const PathGoal& goal, bool avoidMovingUnits)
 {
 	CmpPtr<ICmpPathfinder> cmpPathfinder(GetSimContext(), SYSTEM_ENTITY);
 	if (!cmpPathfinder)
@@ -1227,7 +1239,7 @@
 
 	// Now we need to recompute a short path to the waypoint
 
-	ICmpPathfinder::Goal goal;
+	PathGoal goal;
 	if (m_LongPath.m_Waypoints.empty())
 	{
 		// This was the last waypoint - head for the exact goal
@@ -1236,7 +1248,7 @@
 	else
 	{
 		// Head for somewhere near the waypoint (but allow some leeway in case it's obstructed)
-		goal.type = ICmpPathfinder::Goal::CIRCLE;
+		goal.type = PathGoal::CIRCLE;
 		goal.hw = SHORT_PATH_GOAL_RADIUS;
 		goal.x = targetX;
 		goal.z = targetZ;
@@ -1262,52 +1274,41 @@
 
 	CFixedVector2D pos = cmpPosition->GetPosition2D();
 
-	ICmpPathfinder::Goal goal;
+	PathGoal goal;
+	goal.x = x;
+	goal.z = z;
 
 	if (minRange.IsZero() && maxRange.IsZero())
 	{
-		// Handle the non-ranged mode:
+		// Non-ranged movement:
 
-		// Check whether this point is in an obstruction
-
-		CmpPtr<ICmpObstructionManager> cmpObstructionManager(GetSimContext(), SYSTEM_ENTITY);
-		if (!cmpObstructionManager)
-			return false;
-
-		ICmpObstructionManager::ObstructionSquare obstruction;
-		if (cmpObstructionManager->FindMostImportantObstruction(GetObstructionFilter(true), x, z, m_Radius, obstruction))
-		{
-			// If we're aiming inside a building, then aim for the outline of the building instead
-			// TODO: if we're aiming at a unit then maybe a circle would look nicer?
-
-			goal.type = ICmpPathfinder::Goal::SQUARE;
-			goal.x = obstruction.x;
-			goal.z = obstruction.z;
-			goal.u = obstruction.u;
-			goal.v = obstruction.v;
-			goal.hw = obstruction.hw + m_Radius + g_GoalDelta; // nudge the goal outwards so it doesn't intersect the building itself
-			goal.hh = obstruction.hh + m_Radius + g_GoalDelta;
-		}
-		else
-		{
-			// Unobstructed - head directly for the goal
-			goal.type = ICmpPathfinder::Goal::POINT;
-			goal.x = x;
-			goal.z = z;
-		}
+		// Head directly for the goal
+		goal.type = PathGoal::POINT;
 	}
 	else
 	{
+		// Ranged movement:
+
 		entity_pos_t distance = (pos - CFixedVector2D(x, z)).Length();
 
-		entity_pos_t goalDistance;
 		if (distance < minRange)
 		{
-			goalDistance = minRange + g_GoalDelta;
+			// Too close to target - move outwards to a circle
+			// that's slightly larger than the min range
+			goal.type = PathGoal::INVERTED_CIRCLE;
+			goal.hw = minRange + g_GoalDelta;
 		}
 		else if (maxRange >= entity_pos_t::Zero() && distance > maxRange)
 		{
-			goalDistance = maxRange - g_GoalDelta;
+			// Too far from target - move outwards to a circle
+			// that's slightly smaller than the max range
+			goal.type = PathGoal::CIRCLE;
+			goal.hw = maxRange - g_GoalDelta;
+
+			// If maxRange was abnormally small,
+			// collapse the circle into a point
+			if (goal.hw <= entity_pos_t::Zero())
+				goal.type = PathGoal::POINT;
 		}
 		else
 		{
@@ -1315,15 +1316,6 @@
 			FaceTowardsPointFromPos(pos, x, z);
 			return false;
 		}
-
-		// TODO: what happens if goalDistance < 0? (i.e. we probably can never get close enough to the target)
-
-		goal.type = ICmpPathfinder::Goal::CIRCLE;
-		goal.x = x;
-		goal.z = z;
-
-		// Formerly added m_Radius, but it seems better to go by the mid-point.
-		goal.hw = goalDistance;
 	}
 
 	m_State = STATE_INDIVIDUAL_PATH;
@@ -1349,8 +1341,8 @@
 	bool hasObstruction = false;
 	CmpPtr<ICmpObstructionManager> cmpObstructionManager(GetSimContext(), SYSTEM_ENTITY);
 	ICmpObstructionManager::ObstructionSquare obstruction;
-	if (cmpObstructionManager)
-		hasObstruction = cmpObstructionManager->FindMostImportantObstruction(GetObstructionFilter(true), x, z, m_Radius, obstruction);
+//TODO	if (cmpObstructionManager)
+//		hasObstruction = cmpObstructionManager->FindMostImportantObstruction(GetObstructionFilter(true), x, z, m_Radius, obstruction);
 
 	if (minRange.IsZero() && maxRange.IsZero() && hasObstruction)
 	{
@@ -1422,6 +1414,19 @@
 	if (cmpObstruction)
 		hasObstruction = cmpObstruction->GetObstructionSquare(obstruction);
 
+	if (!hasObstruction)
+	{
+		// The target didn't have an obstruction or obstruction shape, so treat it as a point instead
+
+		CmpPtr<ICmpPosition> cmpTargetPosition(GetSimContext(), target);
+		if (!cmpTargetPosition || !cmpTargetPosition->IsInWorld())
+			return false;
+
+		CFixedVector2D targetPos = cmpTargetPosition->GetPosition2D();
+
+		return MoveToPointRange(targetPos.X, targetPos.Y, minRange, maxRange);
+	}
+
 	/*
 	 * If we're starting outside the maxRange, we need to move closer in.
 	 * If we're starting inside the minRange, we need to move further out.
@@ -1447,103 +1452,88 @@
 	 * (Those units should set minRange to 0 so they'll never be considered *too* close.)
 	 */
 
-	if (hasObstruction)
+	CFixedVector2D halfSize(obstruction.hw, obstruction.hh);
+	PathGoal goal;
+	goal.x = obstruction.x;
+	goal.z = obstruction.z;
+
+	entity_pos_t distance = Geometry::DistanceToSquare(pos - CFixedVector2D(obstruction.x, obstruction.z), obstruction.u, obstruction.v, halfSize);
+
+	if (distance < minRange)
 	{
-		CFixedVector2D halfSize(obstruction.hw, obstruction.hh);
-		ICmpPathfinder::Goal goal;
-		goal.x = obstruction.x;
-		goal.z = obstruction.z;
+		// Too close to the square - need to move away
 
-		entity_pos_t distance = Geometry::DistanceToSquare(pos - CFixedVector2D(obstruction.x, obstruction.z), obstruction.u, obstruction.v, halfSize);
+		// TODO: maybe we should do the ShouldTreatTargetAsCircle thing here?
 
-		if (distance < minRange)
-		{
-			// Too close to the square - need to move away
+		entity_pos_t goalDistance = minRange + g_GoalDelta;
 
-			// TODO: maybe we should do the ShouldTreatTargetAsCircle thing here?
+		goal.type = PathGoal::SQUARE;
+		goal.u = obstruction.u;
+		goal.v = obstruction.v;
+		entity_pos_t delta = std::max(goalDistance, m_Radius + entity_pos_t::FromInt(TERRAIN_TILE_SIZE)/16); // ensure it's far enough to not intersect the building itself
+		goal.hw = obstruction.hw + delta;
+		goal.hh = obstruction.hh + delta;
+	}
+	else if (maxRange < entity_pos_t::Zero() || distance < maxRange)
+	{
+		// We're already in range - no need to move anywhere
+		FaceTowardsPointFromPos(pos, goal.x, goal.z);
+		return false;
+	}
+	else
+	{
+		// We might need to move closer:
 
-			entity_pos_t goalDistance = minRange + g_GoalDelta;
+		// Circumscribe the square
+		entity_pos_t circleRadius = halfSize.Length();
 
-			goal.type = ICmpPathfinder::Goal::SQUARE;
-			goal.u = obstruction.u;
-			goal.v = obstruction.v;
-			entity_pos_t delta = std::max(goalDistance, m_Radius + entity_pos_t::FromInt(TERRAIN_TILE_SIZE)/16); // ensure it's far enough to not intersect the building itself
-			goal.hw = obstruction.hw + delta;
-			goal.hh = obstruction.hh + delta;
-		}
-		else if (maxRange < entity_pos_t::Zero() || distance < maxRange)
+		if (ShouldTreatTargetAsCircle(maxRange, obstruction.hw, obstruction.hh, circleRadius))
 		{
-			// We're already in range - no need to move anywhere
-			FaceTowardsPointFromPos(pos, goal.x, goal.z);
-			return false;
-		}
-		else
-		{
-			// We might need to move closer:
+			// The target is small relative to our range, so pretend it's a circle
 
-			// Circumscribe the square
-			entity_pos_t circleRadius = halfSize.Length();
+			// Note that the distance to the circle will always be less than
+			// the distance to the square, so the previous "distance < maxRange"
+			// check is still valid (though not sufficient)
+			entity_pos_t circleDistance = (pos - CFixedVector2D(obstruction.x, obstruction.z)).Length() - circleRadius;
 
-			if (ShouldTreatTargetAsCircle(maxRange, obstruction.hw, obstruction.hh, circleRadius))
+			if (circleDistance < maxRange)
 			{
-				// The target is small relative to our range, so pretend it's a circle
-
-				// Note that the distance to the circle will always be less than
-				// the distance to the square, so the previous "distance < maxRange"
-				// check is still valid (though not sufficient)
-				entity_pos_t circleDistance = (pos - CFixedVector2D(obstruction.x, obstruction.z)).Length() - circleRadius;
-
-				if (circleDistance < maxRange)
-				{
-					// We're already in range - no need to move anywhere
-					FaceTowardsPointFromPos(pos, goal.x, goal.z);
-					return false;
-				}
-
-				entity_pos_t goalDistance = maxRange - g_GoalDelta;
-
-				goal.type = ICmpPathfinder::Goal::CIRCLE;
-				goal.hw = circleRadius + goalDistance;
+				// We're already in range - no need to move anywhere
+				FaceTowardsPointFromPos(pos, goal.x, goal.z);
+				return false;
 			}
-			else
-			{
-				// The target is large relative to our range, so treat it as a square and
-				// get close enough that the diagonals come within range
 
-				entity_pos_t goalDistance = (maxRange - g_GoalDelta)*2 / 3; // multiply by slightly less than 1/sqrt(2)
+			entity_pos_t goalDistance = maxRange - g_GoalDelta;
 
-				goal.type = ICmpPathfinder::Goal::SQUARE;
-				goal.u = obstruction.u;
-				goal.v = obstruction.v;
-				entity_pos_t delta = std::max(goalDistance, m_Radius + entity_pos_t::FromInt(TERRAIN_TILE_SIZE)/16); // ensure it's far enough to not intersect the building itself
-				goal.hw = obstruction.hw + delta;
-				goal.hh = obstruction.hh + delta;
-			}
+			goal.type = PathGoal::CIRCLE;
+			goal.hw = circleRadius + goalDistance;
 		}
+		else
+		{
+			// The target is large relative to our range, so treat it as a square and
+			// get close enough that the diagonals come within range
 
-		m_State = STATE_INDIVIDUAL_PATH;
-		m_TargetEntity = target;
-		m_TargetOffset = CFixedVector2D();
-		m_TargetMinRange = minRange;
-		m_TargetMaxRange = maxRange;
-		m_FinalGoal = goal;
+			entity_pos_t goalDistance = (maxRange - g_GoalDelta)*2 / 3; // multiply by slightly less than 1/sqrt(2)
 
-		BeginPathing(pos, goal);
-
-		return true;
+			goal.type = PathGoal::SQUARE;
+			goal.u = obstruction.u;
+			goal.v = obstruction.v;
+			entity_pos_t delta = std::max(goalDistance, m_Radius + entity_pos_t::FromInt(TERRAIN_TILE_SIZE)/16); // ensure it's far enough to not intersect the building itself
+			goal.hw = obstruction.hw + delta;
+			goal.hh = obstruction.hh + delta;
+		}
 	}
-	else
-	{
-		// The target didn't have an obstruction or obstruction shape, so treat it as a point instead
 
-		CmpPtr<ICmpPosition> cmpTargetPosition(GetSimContext(), target);
-		if (!cmpTargetPosition || !cmpTargetPosition->IsInWorld())
-			return false;
+	m_State = STATE_INDIVIDUAL_PATH;
+	m_TargetEntity = target;
+	m_TargetOffset = CFixedVector2D();
+	m_TargetMinRange = minRange;
+	m_TargetMaxRange = maxRange;
+	m_FinalGoal = goal;
 
-		CFixedVector2D targetPos = cmpTargetPosition->GetPosition2D();
+	BeginPathing(pos, goal);
 
-		return MoveToPointRange(targetPos.X, targetPos.Y, minRange, maxRange);
-	}
+	return true;
 }
 
 bool CCmpUnitMotion::IsInTargetRange(entity_id_t target, entity_pos_t minRange, entity_pos_t maxRange)
@@ -1620,8 +1610,8 @@
 
 	CFixedVector2D pos = cmpPosition->GetPosition2D();
 
-	ICmpPathfinder::Goal goal;
-	goal.type = ICmpPathfinder::Goal::POINT;
+	PathGoal goal;
+	goal.type = PathGoal::POINT;
 	goal.x = pos.X;
 	goal.z = pos.Y;
 
Index: source/simulation2/components/CCmpTerritoryManager.cpp
===================================================================
--- source/simulation2/components/CCmpTerritoryManager.cpp	(revision 13108)
+++ source/simulation2/components/CCmpTerritoryManager.cpp	(working copy)
@@ -48,15 +48,14 @@
 
 class CCmpTerritoryManager;
 
-class TerritoryOverlay : public TerrainOverlay
+class TerritoryOverlay : public TerrainTextureOverlay
 {
 	NONCOPYABLE(TerritoryOverlay);
 public:
 	CCmpTerritoryManager& m_TerritoryManager;
 
 	TerritoryOverlay(CCmpTerritoryManager& manager);
-	virtual void StartRender();
-	virtual void ProcessTile(ssize_t i, ssize_t j);
+	virtual void BuildTextureRGBA(u8* data, size_t w, size_t h);
 };
 
 class CCmpTerritoryManager : public ICmpTerritoryManager
@@ -269,6 +268,24 @@
 
 REGISTER_COMPONENT_TYPE(TerritoryManager)
 
+/**
+ * Compute the tile indexes on the grid nearest to a given point
+ */
+static void NearestTerritoryTile(entity_pos_t x, entity_pos_t z, int& i, int& j, int w, int h)
+{
+	i = clamp((x / (ICmpObstructionManager::NAVCELL_SIZE * ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE)).ToInt_RoundToNegInfinity(), 0, w-1);
+	j = clamp((z / (ICmpObstructionManager::NAVCELL_SIZE * ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE)).ToInt_RoundToNegInfinity(), 0, h-1);
+}
+
+/**
+ * Returns the position of the center of the given tile
+ */
+static void TerritoryTileCenter(int i, int j, entity_pos_t& x, entity_pos_t& z)
+{
+	x = entity_pos_t::FromInt(i*2 + 1).Multiply(ICmpObstructionManager::NAVCELL_SIZE * ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE / 2);
+	z = entity_pos_t::FromInt(j*2 + 1).Multiply(ICmpObstructionManager::NAVCELL_SIZE * ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE / 2);
+}
+
 /*
 We compute the territory influence of an entity with a kind of best-first search,
 storing an 'open' list of tiles that have not yet been processed,
@@ -279,7 +296,7 @@
 
 typedef PriorityQueueHeap<std::pair<u16, u16>, u32, std::greater<u32> > OpenQueue;
 
-static void ProcessNeighbour(u32 falloff, u16 i, u16 j, u32 pg, bool diagonal,
+static void ProcessNeighbour(u32 falloff, int i, int j, u32 pg, bool diagonal,
 		Grid<u32>& grid, OpenQueue& queue, const Grid<u8>& costGrid)
 {
 	u32 dg = falloff * costGrid.get(i, j);
@@ -294,38 +311,38 @@
 	u32 g = pg - dg; // cost to this tile = cost to predecessor - falloff from predecessor
 
 	grid.set(i, j, g);
-	OpenQueue::Item tile = { std::make_pair(i, j), g };
+	OpenQueue::Item tile = { std::make_pair((u16)i, (u16)j), g };
 	queue.push(tile);
 }
 
 static void FloodFill(Grid<u32>& grid, Grid<u8>& costGrid, OpenQueue& openTiles, u32 falloff)
 {
-	u16 tilesW = grid.m_W;
-	u16 tilesH = grid.m_H;
+	int tilesW = grid.m_W;
+	int tilesH = grid.m_H;
 
 	while (!openTiles.empty())
 	{
 		OpenQueue::Item tile = openTiles.pop();
 
 		// Process neighbours (if they're not off the edge of the map)
-		u16 x = tile.id.first;
-		u16 z = tile.id.second;
+		int x = tile.id.first;
+		int z = tile.id.second;
 		if (x > 0)
-			ProcessNeighbour(falloff, (u16)(x-1), z, tile.rank, false, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x-1, z, tile.rank, false, grid, openTiles, costGrid);
 		if (x < tilesW-1)
-			ProcessNeighbour(falloff, (u16)(x+1), z, tile.rank, false, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x+1, z, tile.rank, false, grid, openTiles, costGrid);
 		if (z > 0)
-			ProcessNeighbour(falloff, x, (u16)(z-1), tile.rank, false, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x, z-1, tile.rank, false, grid, openTiles, costGrid);
 		if (z < tilesH-1)
-			ProcessNeighbour(falloff, x, (u16)(z+1), tile.rank, false, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x, z+1, tile.rank, false, grid, openTiles, costGrid);
 		if (x > 0 && z > 0)
-			ProcessNeighbour(falloff, (u16)(x-1), (u16)(z-1), tile.rank, true, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x-1, z-1, tile.rank, true, grid, openTiles, costGrid);
 		if (x > 0 && z < tilesH-1)
-			ProcessNeighbour(falloff, (u16)(x-1), (u16)(z+1), tile.rank, true, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x-1, z+1, tile.rank, true, grid, openTiles, costGrid);
 		if (x < tilesW-1 && z > 0)
-			ProcessNeighbour(falloff, (u16)(x+1), (u16)(z-1), tile.rank, true, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x+1, z-1, tile.rank, true, grid, openTiles, costGrid);
 		if (x < tilesW-1 && z < tilesH-1)
-			ProcessNeighbour(falloff, (u16)(x+1), (u16)(z+1), tile.rank, true, grid, openTiles, costGrid);
+			ProcessNeighbour(falloff, x+1, z+1, tile.rank, true, grid, openTiles, costGrid);
 	}
 }
 
@@ -343,31 +360,67 @@
 	if (!cmpTerrain->IsLoaded())
 		return;
 
-	u16 tilesW = cmpTerrain->GetTilesPerSide();
-	u16 tilesH = cmpTerrain->GetTilesPerSide();
+	CmpPtr<ICmpPathfinder> cmpPathfinder(GetSimContext(), SYSTEM_ENTITY);
+	ICmpPathfinder::pass_class_t passClassDefault = cmpPathfinder->GetPassabilityClass("territory");
+	ICmpPathfinder::pass_class_t passClassUnrestricted = cmpPathfinder->GetPassabilityClass("unrestricted");
 
+	const Grid<u16>& passGrid = cmpPathfinder->GetPassabilityGrid();
+
+	// Downsample the passability data to count the number of impassable
+	// navcells per territory tile
+	// (TODO: do we really want to average the passability per territory tile,
+	// instead of doing min/max/etc?)
+
+	int tilesW = passGrid.m_W / NAVCELLS_PER_TERRITORY_TILE;
+	int tilesH = passGrid.m_H / NAVCELLS_PER_TERRITORY_TILE;
+
 	m_Territories = new Grid<u8>(tilesW, tilesH);
 
-	// Compute terrain-passability-dependent costs per tile
-	Grid<u8> influenceGrid(tilesW, tilesH);
+	// Downsample passability grid horizontally first
+	Grid<u16> tempPassGrid(passGrid.m_W / NAVCELLS_PER_TERRITORY_TILE, passGrid.m_H);
 
-	CmpPtr<ICmpPathfinder> cmpPathfinder(GetSimContext(), SYSTEM_ENTITY);
-	ICmpPathfinder::pass_class_t passClassDefault = cmpPathfinder->GetPassabilityClass("default");
-	ICmpPathfinder::pass_class_t passClassUnrestricted = cmpPathfinder->GetPassabilityClass("unrestricted");
+	cassert(NAVCELLS_PER_TERRITORY_TILE < 16); // else we might overflow the counters
 
-	const Grid<u16>& passGrid = cmpPathfinder->GetPassabilityGrid();
-	for (u16 j = 0; j < tilesH; ++j)
+	for (int j = 0; j < tempPassGrid.m_H; ++j)
 	{
-		for (u16 i = 0; i < tilesW; ++i)
+		for (int i = 0; i < tempPassGrid.m_W; ++i)
 		{
-			u16 g = passGrid.get(i, j);
+			u32 count = 0;
+			for (u16 di = 0; di < NAVCELLS_PER_TERRITORY_TILE; ++di)
+			{
+				u16 g = passGrid.get(i*NAVCELLS_PER_TERRITORY_TILE + di, j);
+				if (g & passClassUnrestricted)
+					count += 65536; // off the world; force maximum cost
+				else if (g & passClassDefault)
+					count += 1;
+			}
+			tempPassGrid.set(i, j, std::min((u32)65535, count)); // clamp to avoid overflow
+		}
+	}
+
+	// Compute terrain-passability-dependent costs per tile
+
+	Grid<u8> influenceGrid(tilesW, tilesH);
+	for (int j = 0; j < tilesH; ++j)
+	{
+		for (int i = 0; i < tilesW; ++i)
+		{
+			// Downsample vertically
+			u32 count = 0;
+			for (int dj = 0; dj < NAVCELLS_PER_TERRITORY_TILE; ++dj)
+				count += tempPassGrid.get(i, j*NAVCELLS_PER_TERRITORY_TILE + dj);
+
 			u8 cost;
-			if (g & passClassUnrestricted)
-				cost = 255; // off the world; use maximum cost
-			else if (g & passClassDefault)
-				cost = m_ImpassableCost;
+			if (count >= 65535)
+			{
+				cost = 255; // at least partially off the world; use maximum cost
+			}
 			else
-				cost = 1;
+			{
+				// Compute average cost of the cells within this tile
+				u32 totalCells = NAVCELLS_PER_TERRITORY_TILE*NAVCELLS_PER_TERRITORY_TILE;
+				cost = (m_ImpassableCost*count + 1*(totalCells-count)) / totalCells;
+			}
 			influenceGrid.set(i, j, cost);
 		}
 	}
@@ -430,12 +483,12 @@
 
 			CmpPtr<ICmpPosition> cmpPosition(GetSimContext(), *eit);
 			CFixedVector2D pos = cmpPosition->GetPosition2D();
-			u16 i = (u16)clamp((pos.X / (int)TERRAIN_TILE_SIZE).ToInt_RoundToNegInfinity(), 0, tilesW-1);
-			u16 j = (u16)clamp((pos.Y / (int)TERRAIN_TILE_SIZE).ToInt_RoundToNegInfinity(), 0, tilesH-1);
+			int i, j;
+			NearestTerritoryTile(pos.X, pos.Y, i, j, tilesW, tilesH);
 
 			CmpPtr<ICmpTerritoryInfluence> cmpTerritoryInfluence(GetSimContext(), *eit);
 			u32 weight = cmpTerritoryInfluence->GetWeight();
-			u32 radius = cmpTerritoryInfluence->GetRadius() / TERRAIN_TILE_SIZE;
+			u32 radius = (fixed::FromInt(cmpTerritoryInfluence->GetRadius()) / (ICmpObstructionManager::NAVCELL_SIZE * NAVCELLS_PER_TERRITORY_TILE)).ToInt_RoundToNegInfinity();
 			u32 falloff = weight / radius; // earlier check for GetRadius() == 0 prevents divide-by-zero
 
 			// TODO: we should have some maximum value on weight, to avoid overflow
@@ -451,8 +504,8 @@
 			FloodFill(entityGrid, influenceGrid, openTiles, falloff);
 
 			// TODO: we should do a sparse grid and only add the non-zero regions, for performance
-			for (u16 j = 0; j < entityGrid.m_H; ++j)
-				for (u16 i = 0; i < entityGrid.m_W; ++i)
+			for (int j = 0; j < entityGrid.m_H; ++j)
+				for (int i = 0; i < entityGrid.m_W; ++i)
 					playerGrid.set(i, j, playerGrid.get(i, j) + entityGrid.get(i, j));
 		}
 
@@ -460,9 +513,9 @@
 	}
 
 	// Set m_Territories to the player ID with the highest influence for each tile
-	for (u16 j = 0; j < tilesH; ++j)
+	for (int j = 0; j < tilesH; ++j)
 	{
-		for (u16 i = 0; i < tilesW; ++i)
+		for (int i = 0; i < tilesW; ++i)
 		{
 			u32 bestWeight = 0;
 			for (size_t k = 0; k < playerGrids.size(); ++k)
@@ -487,8 +540,8 @@
 		CmpPtr<ICmpPosition> cmpPosition(GetSimContext(), *it);
 
 		CFixedVector2D pos = cmpPosition->GetPosition2D();
-		u16 i = (u16)clamp((pos.X / (int)TERRAIN_TILE_SIZE).ToInt_RoundToNegInfinity(), 0, tilesW-1);
-		u16 j = (u16)clamp((pos.Y / (int)TERRAIN_TILE_SIZE).ToInt_RoundToNegInfinity(), 0, tilesH-1);
+		int i, j;
+		NearestTerritoryTile(pos.X, pos.Y, i, j, tilesW, tilesH);
 
 		u8 owner = (u8)cmpOwnership->GetOwner();
 
@@ -500,12 +553,12 @@
 
 		Grid<u8>& grid = *m_Territories;
 
-		u16 maxi = (u16)(grid.m_W-1);
-		u16 maxj = (u16)(grid.m_H-1);
+		int maxi = grid.m_W-1;
+		int maxj = grid.m_H-1;
 
 		std::vector<std::pair<u16, u16> > tileStack;
 
-#define MARK_AND_PUSH(i, j) STMT(grid.set(i, j, owner | TERRITORY_CONNECTED_MASK); tileStack.push_back(std::make_pair(i, j)); )
+#define MARK_AND_PUSH(i, j) STMT(grid.set(i, j, owner | TERRITORY_CONNECTED_MASK); tileStack.push_back(std::make_pair((u16)(i), (u16)(j))); )
 
 		MARK_AND_PUSH(i, j);
 		while (!tileStack.empty())
@@ -537,27 +590,6 @@
 	}
 }
 
-/**
- * Compute the tile indexes on the grid nearest to a given point
- */
-static void NearestTile(entity_pos_t x, entity_pos_t z, u16& i, u16& j, u16 w, u16 h)
-{
-	i = (u16)clamp((x / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), 0, w-1);
-	j = (u16)clamp((z / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), 0, h-1);
-}
-
-/**
- * Returns the position of the center of the given tile
- */
-static void TileCenter(u16 i, u16 j, entity_pos_t& x, entity_pos_t& z)
-{
-	x = entity_pos_t::FromInt(i*(int)TERRAIN_TILE_SIZE + (int)TERRAIN_TILE_SIZE/2);
-	z = entity_pos_t::FromInt(j*(int)TERRAIN_TILE_SIZE + (int)TERRAIN_TILE_SIZE/2);
-}
-
-// TODO: would be nice not to duplicate those two functions from CCmpObstructionManager.cpp
-
-
 void CCmpTerritoryManager::RasteriseInfluences(CComponentManager::InterfaceList& infls, Grid<u8>& grid)
 {
 	for (CComponentManager::InterfaceList::iterator it = infls.begin(); it != infls.end(); ++it)
@@ -579,15 +611,15 @@
 		CFixedVector2D halfSize(square.hw, square.hh);
 		CFixedVector2D halfBound = Geometry::GetHalfBoundingBox(square.u, square.v, halfSize);
 
-		u16 i0, j0, i1, j1;
-		NearestTile(square.x - halfBound.X, square.z - halfBound.Y, i0, j0, grid.m_W, grid.m_H);
-		NearestTile(square.x + halfBound.X, square.z + halfBound.Y, i1, j1, grid.m_W, grid.m_H);
-		for (u16 j = j0; j <= j1; ++j)
+		int i0, j0, i1, j1;
+		NearestTerritoryTile(square.x - halfBound.X, square.z - halfBound.Y, i0, j0, grid.m_W, grid.m_H);
+		NearestTerritoryTile(square.x + halfBound.X, square.z + halfBound.Y, i1, j1, grid.m_W, grid.m_H);
+		for (int j = j0; j <= j1; ++j)
 		{
-			for (u16 i = i0; i <= i1; ++i)
+			for (int i = i0; i <= i1; ++i)
 			{
 				entity_pos_t x, z;
-				TileCenter(i, j, x, z);
+				TerritoryTileCenter(i, j, x, z);
 				if (Geometry::PointIsInSquare(CFixedVector2D(x - square.x, z - square.z), square.u, square.v, halfSize))
 					grid.set(i, j, (u8)cost);
 			}
@@ -714,52 +746,49 @@
 
 player_id_t CCmpTerritoryManager::GetOwner(entity_pos_t x, entity_pos_t z)
 {
-	u16 i, j;
 	CalculateTerritories();
 	if (!m_Territories)
 		return 0;
 
-	NearestTile(x, z, i, j, m_Territories->m_W, m_Territories->m_H);
+	int i, j;
+	NearestTerritoryTile(x, z, i, j, m_Territories->m_W, m_Territories->m_H);
 	return m_Territories->get(i, j) & TERRITORY_PLAYER_MASK;
 }
 
 bool CCmpTerritoryManager::IsConnected(entity_pos_t x, entity_pos_t z)
 {
-	u16 i, j;
 	CalculateTerritories();
 	if (!m_Territories)
 		return false;
 
-	NearestTile(x, z, i, j, m_Territories->m_W, m_Territories->m_H);
+	int i, j;
+	NearestTerritoryTile(x, z, i, j, m_Territories->m_W, m_Territories->m_H);
 	return (m_Territories->get(i, j) & TERRITORY_CONNECTED_MASK) != 0;
 }
 
-TerritoryOverlay::TerritoryOverlay(CCmpTerritoryManager& manager)
-	: TerrainOverlay(manager.GetSimContext()), m_TerritoryManager(manager)
-{ }
-
-void TerritoryOverlay::StartRender()
+TerritoryOverlay::TerritoryOverlay(CCmpTerritoryManager& manager) :
+	TerrainTextureOverlay((float)ICmpObstructionManager::NAVCELLS_PER_TILE / ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE),
+	m_TerritoryManager(manager)
 {
-	m_TerritoryManager.CalculateTerritories();
 }
 
-void TerritoryOverlay::ProcessTile(ssize_t i, ssize_t j)
+void TerritoryOverlay::BuildTextureRGBA(u8* data, size_t w, size_t h)
 {
-	if (!m_TerritoryManager.m_Territories)
-		return;
+	m_TerritoryManager.CalculateTerritories();
 
-	u8 id = (m_TerritoryManager.m_Territories->get((int) i, (int) j) & ICmpTerritoryManager::TERRITORY_PLAYER_MASK);
+	for (size_t j = 0; j < h; ++j)
+	{
+		for (size_t i = 0; i < w; ++i)
+		{
+			SColor4ub color;
 
-	float a = 0.2f;
-	switch (id)
-	{
-	case 0:  break;
-	case 1:  RenderTile(CColor(1, 0, 0, a), false); break;
-	case 2:  RenderTile(CColor(0, 1, 0, a), false); break;
-	case 3:  RenderTile(CColor(0, 0, 1, a), false); break;
-	case 4:  RenderTile(CColor(1, 1, 0, a), false); break;
-	case 5:  RenderTile(CColor(0, 1, 1, a), false); break;
-	case 6:  RenderTile(CColor(1, 0, 1, a), false); break;
-	default: RenderTile(CColor(1, 1, 1, a), false); break;
+			u8 id = (m_TerritoryManager.m_Territories->get((int)i, (int)j) & ICmpTerritoryManager::TERRITORY_PLAYER_MASK);
+			color = GetColor(id, 64);
+
+			*data++ = color.R;
+			*data++ = color.G;
+			*data++ = color.B;
+			*data++ = color.A;
+		}
 	}
 }
